//
//  ueConnection.h
//
//  Created by eBizCharge on 4/29/14.
//  Copyright (c) 2015 eBizCharge. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SystemConfiguration/SystemConfiguration.h>
#import <netinet/in.h>

typedef enum : NSInteger {
	NotReachable = 0,
	ReachableViaWiFi,
	ReachableViaWWAN
} NetworkStatus;

@interface USAePayLibraryUeConnection : NSObject

/*
 * Returns true if there is internet
 * Returns false if there is no internet connectivity
 */
+(BOOL)isConnected;

/*
 * Use to check the reachability of a host
 */
+(instancetype)reachabilityWithHostName:(NSString *)hostName;

-(NetworkStatus)currentReachabilityStatus;

-(BOOL)connectionRequired;

@end
