//
//  uesoapTransactionObject.h
//
//  Created by eBizCharge on 4/17/14.
//  Copyright (c) 2014 eBizCharge. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "USAePayLibraryUesoapObject.h"

@class USAePayLibraryUesoapTransactionResponse;
@class USAePayLibraryUesoapCheckTrace;
@class USAePayLibraryUesoapTransactionDetail;
@class USAePayLibraryUesoapCreditCardData;
@class USAePayLibraryUesoapAddress;

@interface USAePayLibraryUesoapTransactionObject : USAePayLibraryUesoapObject {
	
	
	NSString *Status; //Status of specified transaction.
	USAePayLibraryUesoapTransactionResponse *Response; //Gateway response details, includes AuthCode etc.
	NSString *TransactionType; //Type of transaction. (Sale, Credit, Void, AuthOnly, etc.)
	USAePayLibraryUesoapCheckTrace *CheckTrace; //Tracking data for check transactions. Includes tracking number, effective posting date, date processed, date settled, date returned and bank notes.
	NSString *DateTime; //Date/time transaction was originally submitted.
	NSString *AccountHolder; //Name of the account holder.
	USAePayLibraryUesoapTransactionDetail 	*Details; //Transaction details. (amount, invoice number, clerk, description, currency, etc.)
	USAePayLibraryUesoapCreditCardData 	*CreditCardData; //Credit card specific data. (card type, number, expiration date, etc.)

	NSString *User; //The username of the person who processed this transaction.
	NSString *Source; //The name of the source key that this transaction was processed under.
	NSString *ServerIP; //IP Address of the server that submitted the transaction to the gateway.
	NSString *ClientIP; //IP Address of client (if passed on from the server).
	NSString *CustomerID; //Customer ID
	USAePayLibraryUesoapAddress 	*BillingAddress; //Billing Address
	USAePayLibraryUesoapAddress 	*ShippingAddress; //Shipping Address
	//FieldValue 	CustomFields 	Array of custom transaction fields 
	
}

@property (readwrite, retain) NSString *Status;
@property (readwrite, retain) USAePayLibraryUesoapTransactionResponse *Response;
@property (readwrite, retain) NSString *TransactionType;
@property (readwrite, retain) USAePayLibraryUesoapCheckTrace *CheckTrace;
@property (readwrite, retain) NSString *DateTime;
@property (readwrite, retain) NSString *AccountHolder;
@property (readwrite, retain) USAePayLibraryUesoapTransactionDetail *Details;
@property (readwrite, retain) USAePayLibraryUesoapCreditCardData *CreditCardData;
@property (readwrite, retain) NSString *User;
@property (readwrite, retain) NSString *Source;
@property (readwrite, retain) NSString *ServerIP;
@property (readwrite, retain) NSString *ClientIP;
@property (readwrite, retain) NSString *CustomerID;
@property (readwrite, retain) USAePayLibraryUesoapAddress *BillingAddress;
@property (readwrite, retain) USAePayLibraryUesoapAddress *ShippingAddress;

-(id) initWithXML:(NSString *)string;


@end
