//
//  iPhoneViewController.m
//  CCProcessingView
//
//  Created by USAePay on 4/28/14.
//  Copyright (c) 2014 USAePay. All rights reserved.
//

#import "iPhoneViewController.h"
#import "USAePayLibraryUesoapTransactionResponse.h" //Needed to output the result response
#import "USAePayLibraryConstants.h"

@interface iPhoneViewController ()

@end

@implementation iPhoneViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    _screenSize = [UIScreen mainScreen].bounds.size;
    
    USAePayLibraryConstants *shareManager = [USAePayLibraryConstants sharedManager];
    
    /*
     * This are the required information, which need to initialize
     * Before doing any transactions
     */
    shareManager.isProduction = true;
    shareManager.sourceKey = @"Your Source Key";
    shareManager.pinNum = @"Your Pin";
	
    /*
     * Initialize the view, and sets delegate to self so the call back methods will get call
     */
    _ccView = [[USAePayLibraryCreditCardView alloc]initWithFrame:CGRectMake(0, 0, _screenSize.width, _screenSize.height)];
    _ccView.delegate = self;

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction)payBtn:(id)sender
{
    /*
     *Hides the keyboard if it's still showing
     */
    if([amountField isFirstResponder])
    {
        [amountField resignFirstResponder];
    }
    
    if(amountField.text.length==0)
    {
        amountField.text = @"0.00";
    }
    
    /*
     * Set the total amount that will gets charge to the credit card
     * If charge amount doesn't set, the default will be set $0.00
     */
    _ccView.customUI.totalAmount = amountField.text;
    _customView = _ccView.getIPhoneView;
    
    [self.view addSubview:_customView];
    
}

/*
 * This delegate method gets call when the cancel button is clicked
 */
-(void)cancelBtnClickedDelegate
{
    [_customView removeFromSuperview];
    _customView = nil;
}

/*
 * This method gets called when the payment is finished processing
 */
-(void)transactionCompleted :(USAePayLibraryUesoapTransactionResponse *)response
{
    [_customView removeFromSuperview];
    _customView = nil;
    
    /*
     * Use an alert to display the payment result status
     */
    
    UIAlertView *paymentResult = [[UIAlertView alloc]initWithTitle:@"Payment status" message:response.Result delegate:self cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
    
    [paymentResult show];
}

@end
