//
//  CreditCardView.h
//  
//  Created by eBizCharge on 4/18/14.
//  Copyright (c) 2015 eBizCharge. All rights reserved.
//
//  Purpose: Handles all the event for credit card field form
// 

#import <UIKit/UIKit.h>
#import "USAePayLibraryCustomUI.h"

@class USAePayLibraryUesoapTransactionResponse;

@interface USAePayLibraryCreditCardView : UIView

@property(nonatomic) id delegate;

/*
 * Classes
 */
@property(nonatomic, retain)USAePayLibraryCustomUI *customUI;


/*
 * This method returns the iphone view for credit card form
 * It will automaitcally deteremine the current device orientation
 * Then returns the correct view base on the orientation
 */
-(UIView *)getIPhoneView;

/*
 * This method returns the iPad view for credit card form
 * It will automaitcally deteremine the current device orientation
 * Then returns the correct view base on the orientation
 */
-(UIView *)getIPadView;

/*
 * This is the delegate method for the cancel button
 * You have to handle removing the veiw from the superview
 */
-(void)cancelBtnClickedDelegate;

/*
 * This delegate method gets call when transaction is completed
 * The method returns USAePayLibraryUesoapTransactionResponse object
 * Look at USAePayLibraryUesoapTransactionResponse class to get all its property
 */
-(void)transactionCompleted :(USAePayLibraryUesoapTransactionResponse *)response;

@end
